# SPDX-License-Identifier: AGPL-3.0-or-later
# Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
# Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
#
# DAMASK is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import pytest
import numpy as np

import damask

@pytest.fixture
def res_path(res_path_base):
    """Directory containing testing resources."""
    return res_path_base/'damage_scaling'


def test_resolution(res_path,tmp_path,copy_files):
    copy_files(res_path,tmp_path)
    for grid in ['40','80']:
        load = f'tension{grid}'
        material = 'material'
        job = f'{grid}_{load}'
        damask.util.run(f'damask_grid -l {load}.yaml -g {grid}.vti -m {material}.yaml -j {job} -n numerics.yaml',
                        wd=tmp_path)
        r = damask.Result(f'{tmp_path}/{job}.hdf5')
        P = [np.average(P_[:,0,0]) for P_ in r.place('P').values()]
        assert np.max(P) > 20e6
        assert P[-1] < 17e6
